---
title: Patch Bulk Variant Contents
description: The operation PATCH {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents with the required filter variant eq {{variantName}} bulk changes the value of variant for all contents that meet the filter requirements. The variant value in the filter is the current value. The variant value in the request body is the new value. The new value is returned in the response.
component: pingone-api
page_id: pingone-api:platform:notifications/notifications-templates/patch-bulk-variant-contents
canonical_url: https://developer.pingidentity.com/pingone-api/platform/notifications/notifications-templates/patch-bulk-variant-contents.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Patch Bulk Variant Contents

##

```none
PATCH {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}
```

The operation `PATCH {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents` with the required filter `variant eq {{variantName}}` bulk changes the value of `variant` for all contents that meet the filter requirements. The `variant` value in the filter is the current value. The `variant` value in the request body is the new value. The new value is returned in the response.

No other filters are supported.

* Refer to [Notifications](../../notifications.html) and [Notifications Templates](../notifications-templates.html) for important overview information.

> **Collapse: Query parameters**
>
> | Parameter | Description                                                                                                        |
> | --------- | ------------------------------------------------------------------------------------------------------------------ |
> | `filter`  | **Required** Use the `filter` parameter with the `variant eq {{variantName}}` value to specify contents to update. |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
"variant": "variant_D"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PATCH '{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
"variant": "variant_D"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Patch);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"""variant"": ""variant_D""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}"
  method := "PATCH"

  payload := strings.NewReader(`{
"variant": "variant_D"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PATCH /v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
"variant": "variant_D"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n\"variant\": \"variant_D\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}")
  .method("PATCH", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}",
  "method": "PATCH",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "variant": "variant_D"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PATCH',
  'url': '{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "variant": "variant_D"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}"

payload = json.dumps({
  "variant": "variant_D"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PATCH", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}');
$request->setMethod('PATCH');
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n"variant": "variant_D"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Patch.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "variant": "variant_D"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n\"variant\": \"variant_D\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents?filter=variant%20eq%20{{variantName}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PATCH"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication/contents"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "template": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication"
        },
        "next": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication/contents?cursor=a4534dd8-3feb-43d7-a0aa-77c672484ef6"
        }
    },
    "_embedded": {
        "contents": [
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication/contents/00ba533d-fdaf-4ac2-a0e3-6458a122f1b4"
                    },
                    "template": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication"
                    },
                    "environment": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                    }
                },
                "id": "00ba533d-fdaf-4ac2-a0e3-6458a122f1b4",
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "createdAt": "2021-01-14T06:33:29.126Z",
                "updatedAt": "2021-01-14T06:33:29.126Z",
                "locale": "en",
                "variant": "variant_D",
                "template": {
                    "id": "strong_authentication"
                },
                "title": "Test Push",
                "body": " Your OTP is ${OTP}",
                "deliveryMethod": "Push",
                "default": false
            },
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication/contents/a4534dd8-3feb-43d7-a0aa-77c672484ef6"
                    },
                    "template": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication"
                    },
                    "environment": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                    }
                },
                "id": "a4534dd8-3feb-43d7-a0aa-77c672484ef6",
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "createdAt": "2021-01-14T06:30:40.036Z",
                "updatedAt": "2021-01-14T06:30:40.036Z",
                "locale": "en",
                "variant": "variant_D",
                "template": {
                    "id": "strong_authentication"
                },
                "subject": "Test Email",
                "body": " Your OTP is ${OTP}",
                "deliveryMethod": "Email",
                "default": false
            }
        ]
    },
    "count": 2,
    "size": 2
}
```
